#ifndef GRAPHICS_HPP
#define GRAPHICS_HPP

#include <iostream>
#include <boost/foreach.hpp>
#define foreach BOOST_FOREACH

#include "graphicsheader.hpp"

#include "model.hpp"
#include "font.hpp"
#include "icons.hpp"

const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
const int SCREEN_BPP = 32;

class GraphicsEngine {
public:
  vector<Model*> models;
  FontRenderer* fontrenderer;
  IconRenderer* iconrenderer;
  void flip();
  GraphicsEngine();
  GLuint loadmodel(const string& mesh,const string& texture);
  int resizeWindow( int width, int height );
  CMesh* g_pMesh;
  bool g_fVBOSupported;
  void drawpane(int x1, int x2, int y1, int y2);
private:
  void initGL();
  SDL_Surface* screen;
};

#endif /* GRAPHICS_HPP */
