#ifndef GRAPHICS_HEADER
#define GRAPHICS_HEADER

#ifdef __APPLE__
#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
#else
#include <SDL\SDL.h>
#include <SDL\SDL_opengl.h>

extern PFNGLBINDBUFFERARBPROC glBindBufferARB;
extern PFNGLGENBUFFERSARBPROC glGenBuffersARB;
extern PFNGLBUFFERDATAARBPROC glBufferDataARB;
extern PFNGLDELETEBUFFERSARBPROC glDeleteBuffersARB;
#endif

			// VBO Deletion Procedure

class CVert									// Vertex Class
{
public:
	float x;								// X Component
	float y;								// Y Component
};
typedef CVert CVec;								// The Definitions Are Synonymous

class CTexCoord									// Texture Coordinate Class
{
public:
	float u;								// U Component
	float v;								// V Component
};

class CMesh
{
public:
	// Mesh Data
	int		m_nVertexCount;						// Vertex Count
	CVert*		m_pVertices;						// Vertex Data
	CTexCoord*	m_pTexCoords;						// Texture Coordinates
	unsigned int	m_nTextureId;						// Texture ID
  float* pointarray;
  int pointcount;
  unsigned int* indexarray;
  int indexcount;
	// Vertex Buffer Object Names
	unsigned int	m_nVBOVertices;						// Vertex VBO Name
	unsigned int	m_nVBOIndices;					// Vertex indices

public:
	CMesh(){};								// Mesh Constructor
	~CMesh(){};								// Mesh Deconstructor

	// Heightmap Loader
	// Single Point Height
    void LoadHeightmap( );	// VBO Build Function
	void BuildVBOs();
	void BuildIndexArray();
};

bool IsExtensionSupported( char* szTargetExtension );




#endif /* GRAPHICS_HEADER */
