#include "engineinstance.hpp"

#include "intropart.hpp"
#include "titlepart.hpp"
#include "levelselect.hpp"
#include "mainpart.hpp"

GameEngine::GameEngine()
{
//    savedata->setmaxlevel(0);

    global_variables = new Global_Variables();
    global_variables->leveldata=new LevelData("levels/level1.lua");
    global_variables->maxlevel=savedata->getmaxlevel();;
    global_variables->level=global_variables->maxlevel  ;
//	soundengine->loadsound("audio/blip.wav");
//  soundengine->loadsound("audio/pickup.wav");
//  soundengine->loadsound("audio/steps.wav");
    soundengine->streamtrack("audio/0.mp3");

    section.push_back(new IntroPart ( this , global_variables ) );
    section.push_back(new TitlePart ( this , global_variables ) );
    section.push_back(new MainPart  ( this , global_variables ) );
    section.push_back(new LevelSelectPart  ( this , global_variables ) );

}

GameEngine::~GameEngine()
{
}


int GameEngine::control(int oldpart, int message)
{
    if (message<0)
        return -1;

    switch (oldpart)
    {
    case 0://intro
        return 1;
        break;
    case 1://title
        return 3;//goto level select
        break;
    case 2://main game
        switch (message)
        {
        case 1://finish level
            savedata->setmaxlevel(global_variables->maxlevel);
			soundengine->streamtrack("audio/0.mp3");				
            return 3;//go back to level select screen
            break;
        case 3:
			soundengine->streamtrack("audio/0.mp3");				
            return 3;
            break;
        default://should never get her
            return -1;
            break;
        }
        break;
    case 3://stage select
        switch (message)
        {
        case 3://goto menu
            return 1;
            break;
        case 1://goto game
			soundengine->streamtrack("audio/1.mp3");
            return 2;
            break;
        }
        break;
    }
    return -1;
}
