#include "intropart.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"

void IntroPart::reset()
{
  state->gstimer=0;
}

IntroPart::IntroPart(const SubengineInterface* subengines, Global_Variables* p_global_variables):
EnginePart(subengines),
t(0),
u(0),
v(1),
state(new Intro_State),
global_variables(p_global_variables)
{
};

IntroPart::~IntroPart()
{
  delete state;
}

int IntroPart::input(const SDL_Event& event)
{
  if( event.type == SDL_KEYDOWN )
  {
    switch( event.key.keysym.sym )
    {
      case SDLK_ESCAPE:
        return 1;
        break;
      case SDLK_SPACE:
          return 1;
      default:
        break;
    }
  }

  if( event.type == SDL_QUIT )
  {
    return -1;
  }

  return 0;
}

int IntroPart::logic()
{
	if (t < 1)
		t += 0.02;
	else
	{
		if (u < 1.5)
			u += 0.02;
		else
		{
			if (v > 0)
				v -= 0.04;
			else return 1;
		}
	}

	return 0;
}

void IntroPart::draw()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	glMatrixMode(GL_MODELVIEW);

		glLoadIdentity();
	
	glBlendFunc (GL_SRC_ALPHA,
				 GL_ONE_MINUS_SRC_ALPHA) ;
		glColor4f(min(t, v)/3.0f, min(t, v)/3.0f, min(t, v)/3.0f, 1.0f);
		glBegin(GL_QUADS);
		glVertex2f(-0.5f, +0.5f);
		glVertex2f(+0.5f, +0.5f);
		glVertex2f(+0.5f, -0.5f);
		glVertex2f(-0.5f, -0.5f);
		glEnd();
		
		glColor4f(min(1.0f, v)/4.0f, min(1.0f, v)/4.0f,  min(1.0f, v)/4.0f,1.0f);
		glBegin(GL_TRIANGLES);
		glVertex2f(-0.4, -2.0f + 1.55 * t);
		glVertex2f(+0.4f, -2.0f + 1.55 * t);
		glVertex2f(0.0f, -1.1f + 1.55 * t);
		glEnd();
		
		
		glColor4f(min(u, v)/2.0f, min(u, v)/2.0f, min(u, v)/2.0f, 1.0f);
		glBegin(GL_TRIANGLES);
		glVertex2f(-0.4 + 0.45, 2.0f - 1.525);
		glVertex2f(+0.4f + 0.45, 2.0f - 1.525);
		glVertex2f(0.0f + 0.45, 1.1f - 1.525);
		glEnd();
		
	
		glTranslatef(-0.7, 0.05, 0);
		glScalef(1.5, 1.5, 1.5);
		glColor4f(min(u, v),min(u, v), min(u, v), 1.0f);
	glBlendFunc(GL_ONE, GL_ONE);
		graphicsengine->fontrenderer->glPrint(200,250,"increpare presents",0);
		glTranslatef(0, -0.15, 0);
	
	graphicsengine->resizeWindow(640, 480);
}
