#include "levelselect.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"


void LevelSelectPart::reset()
{
    buttonoption=0;
//DOES NOT RESET
}

static void param1(int& param, bool& b)
{
    param=1;
}
static void param2(int& param, bool& b)
{
    param=2;
}

LevelSelectPart::LevelSelectPart(const SubengineInterface* subengines, Global_Variables* p_global_variables):
        EnginePart(subengines),
        state(new LevelSelect_State),
        global_variables(p_global_variables)
{
    global_variables->maxlevel=subengines->savedata->getmaxlevel();
    widgets.push_back(new Level_Select_Bar(74,205,475,54,"select level",20,global_variables->maxlevel,global_variables->level,true));
    widgets.push_back(new Text_Button(36,480-434,graphicsengine->fontrenderer,"menu","menu",true,&param1,buttonoption,0));
    widgets.push_back(new Text_Button(520,480-434,graphicsengine->fontrenderer,"start","start",true,&param2,buttonoption,0));

    capturing=NULL;
};

LevelSelectPart::~LevelSelectPart()
{
    delete state;
}

int LevelSelectPart::input(const SDL_Event& event)
{

    if ( event.type == SDL_KEYDOWN )
    {
        switch ( event.key.keysym.sym )
        {
        case SDLK_ESCAPE:
            return 3;
            break;
        default:
            break;
        }
    }

    if (capturing==NULL)
    {
        //statustext=nulltext;
        foreach (Screen_Element* el, widgets)
        {
            if (el->isat(mx,480-my) && el->enabled)
            {
                //statustext=el->tooltip;
                el->mouseinput(mx,480-my,mb1);
                capturing=el;
                el->focused=true;
                break;
            }
            else
                el->focused=false;
        }
    }
    else
    {
        if (capturing->isat(mx,480-my))
        {
            capturing->mouseinput(mx,480-my,mb1);
        }
        else if (!mb1)
        {
            capturing->uncapture();
            capturing=NULL;
        }
    }

    return 0;
}

int LevelSelectPart::logic()
{
    if (buttonoption==1)//clicked 'menu'
    {
        return 3;
    }
    else if (buttonoption==2)//clicked 'begin'
    {
        stringstream path;
        path<<"levels/level"<<global_variables->level+1<<".lua";
        global_variables->leveldata->loaddata(path.str());
      return 1;
    }
    return 0;
}

void LevelSelectPart::draw()
{
        glClearColor(0,0,0,1);
    glClear( GL_COLOR_BUFFER_BIT  );
    glDisable(GL_TEXTURE_2D);

    for (unsigned int i=0;i<widgets.size();i++)
    {
        widgets[i]->draw();
    }

    glColor3f(1.0f,1.0f,1.0f);

    stringstream ss;
    ss<<"Episode "<<global_variables->level+1;
    graphicsengine->fontrenderer->glPrint(223,480-164,ss.str().c_str(),0);
    //graphicsengine->fontrenderer->glPrint(188,480-72,"eek",0);
    graphicsengine->fontrenderer->glPrint(74,480-(205+54+40),"Past",0);
    graphicsengine->fontrenderer->glPrint(74+470-6*16,480-(205+54+40),"Future",0);

//    74,205,475,54
      //draw mouse cursor
    glColor3f(0.5f,0.5f,1.0f);
    glBegin(GL_LINE_LOOP);
    glVertex2f(mx,my+4);
    glVertex2f(mx+4,my);
    glVertex2f(mx,my-4);
    glVertex2f(mx-4,my);
    glEnd();

}
