#ifndef LOADER_HPP
#define LOADER_HPP

#include <vector>
#include <string>
using namespace std;

#include "math.hpp"

#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"

struct Demographics {
  float a;
  float b;
};

struct DialogueInfo {
    int speaker;
    string dialogue;
};

struct RaceProfile {
    float aggression;
    float mortality;
    float migrationspeed;
};

struct WinCondition {
    int city;
    int people;
    string condition;
    float amount;
};

struct EnabledArrows {
    bool both;
    bool player;
    bool enemy;
};

struct Famine {
    int city;
    float a;
    float b;
    float rate;
};

class LevelData {
    public:
    EnabledArrows enabledarrows;
    LevelData(string s);
    void loaddata(string s);
    vector<string> names;
    vector<DialogueInfo> intro;
    vector<DialogueInfo> outro;
    vector<Point> cities;
    vector<Demographics> populations;
    vector<RaceProfile> profiles;
    vector<Famine> famines;
    vector<WinCondition> winconditions;
    private:
};

#endif /* LOADER_HPP */
