#include "titlepart.hpp"
#include "mainpart.hpp"
#include "gamestrings.hpp"
#include <math.h>


static void fastline(GLfloat x1,GLfloat y1,GLfloat x2,GLfloat y2)
{
    glBegin(GL_LINES);
    glVertex2f(x2,y2);
    //glColor3f(10.6f,0.8f,1.0f);
    glVertex2f(x1,y1);
    glEnd();
}

void TitlePart::reset()
{
    buttonoption=0;
//DOES NOT RESET
}

static void param1(int& param, bool& b)
{
    param=1;
}

static void param2(int& param, bool& b)
{
    param=2;
}

TitlePart::TitlePart(const SubengineInterface* subengines, Global_Variables* p_global_variables):
        EnginePart(subengines),
        state(new TitlePart_State),
        global_variables(p_global_variables)
{
    widgets.push_back(new Text_Button(253,480-258,graphicsengine->fontrenderer,"begin","begin",true,&param1,buttonoption,0));
    widgets.push_back(new Text_Button(253,480-309,graphicsengine->fontrenderer,"quit","quit",true,&param2,buttonoption,0));

    capturing=NULL;
    curselected=0;
    oldcurselected=0;
};

TitlePart::~TitlePart()
{
    delete state;
}

int TitlePart::input(const SDL_Event& event)
{

    if ( event.type == SDL_KEYDOWN )
    {
        switch ( event.key.keysym.sym )
        {
        case SDLK_ESCAPE:
            return -1;
            break;
        default:
            break;
        }
    }

    if (capturing==NULL)
    {
        //statustext=nulltext;
        foreach (Screen_Element* el, widgets)
        {
            if (el->isat(mx,480-my) && el->enabled)
            {
                //statustext=el->tooltip;
                el->mouseinput(mx,480-my,mb1);
                capturing=el;
                el->focused=true;
                break;
            }
            else
                el->focused=false;
        }
    }
    else
    {
        if (capturing->isat(mx,480-my))
        {
            capturing->mouseinput(mx,480-my,mb1);
        }
        else if (!mb1)
        {
            capturing->uncapture();
            capturing=NULL;
        }
    }

    return 0;
}

int TitlePart::logic()
{
/*    if (curselected!=oldcurselected)
    {
        stringstream path;
        path<<"levels/level"<<curselected<<".lua";
        global_variables->leveldata->loaddata(path.str());
        oldcurselected=curselected;
    }*/
	theta+=0.01f;
    if (buttonoption==1)//clicked 'begin'
    {
        return (1);
    }
    else if (buttonoption==2)//clicked 'quit'
    {
      return -1;
    }
    return 0;
}

void TitlePart::draw()
{
    glClearColor(0,0,0,1);
    glClear( GL_COLOR_BUFFER_BIT  );
    glDisable(GL_TEXTURE_2D);

    glColor3f(1.0f,1.0f,1.0f);
    for (unsigned int i=0;i<widgets.size();i++)
    {
        widgets[i]->draw();
    }

    glColor3f(0.1f,0.1f,1.0f);
    fastline((150.0f+272.0f)/2.0f+150*cos(theta),(74.0f+344.0f)/2.0f+150*sin(theta),(150.0f+272.0f)/2.0f-150*cos(theta),(74.0f+344.0f)/2.0f-150*sin(theta));
    fastline((264.0f+344.0f)/2.0f+100*cos(theta+0.5f),(124.0f+274.0f)/2.0f+100*sin(theta+0.5f),(362.0f+344.0f)/2.0f-100*cos(theta+0.5f),(124.0f+274.0f)/2.0f-100*sin(theta+0.5f));
    fastline((362.0f+412.0f)/2.0f+50*cos(theta+1.0f),(136.0f+188.0f)/2.0f+50*sin(theta+1.0f),(362.0f+412.0f)/2.0f-50*cos(theta+1.0f),(136.0f+188.0f)/2.0f-50*sin(theta+1.0f));
//    fastline(264,124,344,274);
  //  fastline(362,136,412,188);
    glColor3f(1.0f,1.0f,1.0f);

    graphicsengine->fontrenderer->glPrint(181,480-176,"Opera Omnia",0);

//    74,205,475,54
      //draw mouse cursor
    glColor3f(0.5f,0.5f,1.0f);
    glBegin(GL_LINE_LOOP);
    glVertex2f(mx,my+4);
    glVertex2f(mx+4,my);
    glVertex2f(mx,my-4);
    glVertex2f(mx-4,my);
    glEnd();

}
